2024-06-25 06:11:48 -07:00
|
|
|
"""
|
|
|
|
This schematics file contains all designs related to tool handles
|
|
|
|
"""
|
|
|
|
from dataclasses import dataclass
|
|
|
|
import cadquery as Cq
|
2024-06-26 08:28:25 -07:00
|
|
|
import nhf.metric_threads as NMt
|
2024-06-25 06:11:48 -07:00
|
|
|
|
|
|
|
@dataclass(frozen=True)
|
|
|
|
class Handle:
|
|
|
|
"""
|
|
|
|
Characteristic of a tool handle
|
2024-06-26 08:28:25 -07:00
|
|
|
|
|
|
|
This assumes the handle segment material does not have threads. Each segment
|
|
|
|
attaches to two insertions, which have threads on the inside. A connector
|
|
|
|
has threads on the outside and joints two insertions.
|
|
|
|
|
|
|
|
Note that all the radial sizes are diameters (in mm).
|
2024-06-25 06:11:48 -07:00
|
|
|
"""
|
|
|
|
|
2024-06-26 08:28:25 -07:00
|
|
|
# Outer and inner radius for the handle usually come in standard sizes
|
|
|
|
diam: float = 38
|
|
|
|
diam_inner: float = 33
|
|
|
|
|
|
|
|
# Major diameter of the internal threads, following ISO metric screw thread
|
|
|
|
# standard. This determines the wall thickness of the insertion.
|
|
|
|
diam_threading: float = 27.0
|
2024-06-25 06:11:48 -07:00
|
|
|
|
2024-06-26 08:28:25 -07:00
|
|
|
thread_pitch: float = 3.0
|
2024-06-25 06:11:48 -07:00
|
|
|
|
2024-06-26 08:28:25 -07:00
|
|
|
# Internal cavity diameter. This determines the wall thickness of the connector
|
|
|
|
diam_connector_internal: float = 18.0
|
2024-06-25 06:11:48 -07:00
|
|
|
|
2024-06-26 08:28:25 -07:00
|
|
|
# If set to true, do not generate threads
|
|
|
|
simplify_geometry: bool = True
|
2024-06-25 06:11:48 -07:00
|
|
|
|
|
|
|
# Length for the rim on the female connector
|
|
|
|
rim_length: float = 5
|
|
|
|
|
|
|
|
insertion_length: float = 60
|
|
|
|
|
2024-06-26 08:28:25 -07:00
|
|
|
# Amount by which the connector goes into the segment
|
2024-06-25 06:11:48 -07:00
|
|
|
connector_length: float = 60
|
|
|
|
|
|
|
|
def __post_init__(self):
|
2024-06-26 08:28:25 -07:00
|
|
|
assert self.diam > self.diam_inner, "Material thickness cannot be <= 0"
|
|
|
|
assert self.diam_inner > self.diam_insertion_internal, "Threading radius is too big"
|
|
|
|
assert self.diam_insertion_internal > self.diam_connector_external
|
|
|
|
assert self.diam_connector_external > self.diam_connector_internal, "Internal diameter is too large"
|
2024-06-25 06:11:48 -07:00
|
|
|
assert self.insertion_length > self.rim_length
|
|
|
|
|
|
|
|
@property
|
2024-06-26 08:28:25 -07:00
|
|
|
def diam_insertion_internal(self):
|
|
|
|
r = NMt.metric_thread_major_radius(
|
|
|
|
self.diam_threading,
|
|
|
|
self.thread_pitch,
|
|
|
|
internal=True)
|
|
|
|
return r * 2
|
|
|
|
|
2024-06-25 06:11:48 -07:00
|
|
|
@property
|
2024-06-26 08:28:25 -07:00
|
|
|
def diam_connector_external(self):
|
|
|
|
r = NMt.metric_thread_minor_radius(
|
|
|
|
self.diam_threading,
|
|
|
|
self.thread_pitch)
|
|
|
|
return r * 2
|
2024-06-25 06:11:48 -07:00
|
|
|
|
|
|
|
def segment(self, length: float):
|
|
|
|
result = (
|
|
|
|
Cq.Workplane()
|
2024-06-26 08:28:25 -07:00
|
|
|
.cylinder(
|
|
|
|
radius=self.diam / 2,
|
|
|
|
height=length)
|
2024-06-25 06:11:48 -07:00
|
|
|
)
|
|
|
|
result.faces("<Z").tag("mate1")
|
|
|
|
result.faces(">Z").tag("mate2")
|
|
|
|
return result
|
|
|
|
|
2024-07-01 17:59:42 -07:00
|
|
|
def _external_thread(self, length=None):
|
|
|
|
if length is None:
|
|
|
|
length = self.insertion_length
|
2024-06-26 08:28:25 -07:00
|
|
|
return NMt.external_metric_thread(
|
|
|
|
self.diam_threading,
|
|
|
|
self.thread_pitch,
|
2024-07-01 17:59:42 -07:00
|
|
|
length,
|
2024-06-26 08:28:25 -07:00
|
|
|
top_lead_in=True)
|
|
|
|
def _internal_thread(self):
|
|
|
|
return NMt.internal_metric_thread(
|
|
|
|
self.diam_threading,
|
|
|
|
self.thread_pitch,
|
|
|
|
self.insertion_length)
|
|
|
|
|
2024-07-01 17:59:42 -07:00
|
|
|
def insertion(self, holes=[]):
|
2024-06-25 06:11:48 -07:00
|
|
|
"""
|
|
|
|
This type of joint is used to connect two handlebar pieces. Each handlebar
|
|
|
|
piece is a tube which cannot be machined, so the joint connects to the
|
|
|
|
handle by glue.
|
|
|
|
|
|
|
|
Tags:
|
|
|
|
* lip: Co-planar Mates to the rod
|
|
|
|
* mate: Mates to the connector
|
2024-07-01 17:59:42 -07:00
|
|
|
|
|
|
|
WARNING: A tolerance lower than the defualt (maybe 5e-4) is required for
|
|
|
|
STL export.
|
|
|
|
|
|
|
|
Set `holes` to the heights for drilling holes into the model for resin
|
|
|
|
to flow out.
|
2024-06-25 06:11:48 -07:00
|
|
|
"""
|
|
|
|
result = (
|
|
|
|
Cq.Workplane('XY')
|
|
|
|
.cylinder(
|
2024-06-26 08:28:25 -07:00
|
|
|
radius=self.diam_inner / 2,
|
2024-06-25 06:11:48 -07:00
|
|
|
height=self.insertion_length - self.rim_length,
|
|
|
|
centered=[True, True, False])
|
|
|
|
)
|
2024-06-26 08:28:25 -07:00
|
|
|
result.faces(">Z").tag("rim")
|
|
|
|
if self.rim_length > 0:
|
|
|
|
result = (
|
|
|
|
result.faces(">Z")
|
|
|
|
.workplane()
|
|
|
|
.circle(self.diam / 2)
|
|
|
|
.extrude(self.rim_length)
|
|
|
|
.faces(">Z")
|
|
|
|
.hole(self.diam_insertion_internal)
|
|
|
|
)
|
2024-06-25 06:11:48 -07:00
|
|
|
result.faces(">Z").tag("mate")
|
2024-06-26 08:28:25 -07:00
|
|
|
if not self.simplify_geometry:
|
|
|
|
thread = self._internal_thread().val()
|
|
|
|
result = result.union(thread)
|
2024-07-01 17:59:42 -07:00
|
|
|
for h in holes:
|
|
|
|
cyl = Cq.Solid.makeCylinder(
|
|
|
|
radius=2,
|
|
|
|
height=self.diam * 2,
|
|
|
|
pnt=(-self.diam, 0, h),
|
|
|
|
dir=(1, 0, 0))
|
|
|
|
result = result.cut(cyl)
|
2024-06-25 06:11:48 -07:00
|
|
|
return result
|
|
|
|
|
2024-07-01 17:59:42 -07:00
|
|
|
def connector(self, solid: bool = True):
|
2024-06-25 06:11:48 -07:00
|
|
|
"""
|
|
|
|
Tags:
|
|
|
|
* mate{1,2}: Mates to the connector
|
2024-07-01 17:59:42 -07:00
|
|
|
|
|
|
|
WARNING: A tolerance lower than the defualt (maybe 2e-4) is required for
|
|
|
|
STL export.
|
2024-06-25 06:11:48 -07:00
|
|
|
"""
|
|
|
|
result = (
|
|
|
|
Cq.Workplane('XY')
|
|
|
|
.cylinder(
|
2024-06-26 08:28:25 -07:00
|
|
|
radius=self.diam / 2,
|
2024-06-25 06:11:48 -07:00
|
|
|
height=self.connector_length,
|
|
|
|
)
|
|
|
|
)
|
|
|
|
for (tag, selector) in [("mate1", "<Z"), ("mate2", ">Z")]:
|
|
|
|
result.faces(selector).tag(tag)
|
|
|
|
result = (
|
|
|
|
result
|
|
|
|
.faces(selector)
|
|
|
|
.workplane()
|
2024-06-26 08:28:25 -07:00
|
|
|
.circle(self.diam_connector_external / 2)
|
2024-06-25 06:11:48 -07:00
|
|
|
.extrude(self.insertion_length)
|
|
|
|
)
|
|
|
|
if not solid:
|
2024-06-26 08:28:25 -07:00
|
|
|
result = result.faces(">Z").hole(self.diam_connector_internal)
|
|
|
|
if not self.simplify_geometry:
|
|
|
|
thread = self._external_thread().val()
|
|
|
|
result = (
|
|
|
|
result
|
|
|
|
.union(
|
|
|
|
thread
|
2024-06-26 16:27:36 -07:00
|
|
|
.located(Cq.Location((0, 0, self.connector_length / 2))))
|
2024-06-26 08:28:25 -07:00
|
|
|
.union(
|
|
|
|
thread
|
2024-07-01 17:59:42 -07:00
|
|
|
.rotate((0,0,0), (1,0,0), angleDegrees=180)
|
2024-06-26 16:27:36 -07:00
|
|
|
.located(Cq.Location((0, 0, -self.connector_length / 2))))
|
2024-06-26 08:28:25 -07:00
|
|
|
)
|
2024-06-25 06:11:48 -07:00
|
|
|
return result
|
|
|
|
|
|
|
|
def one_side_connector(self):
|
|
|
|
result = (
|
|
|
|
Cq.Workplane('XY')
|
|
|
|
.cylinder(
|
2024-06-26 08:28:25 -07:00
|
|
|
radius=self.diam / 2,
|
2024-06-25 06:11:48 -07:00
|
|
|
height=self.rim_length,
|
|
|
|
)
|
|
|
|
)
|
2024-06-26 09:01:01 -07:00
|
|
|
result.faces(">Z").tag("mate")
|
|
|
|
result.faces("<Z").tag("base")
|
2024-06-25 06:11:48 -07:00
|
|
|
result = (
|
|
|
|
result
|
2024-06-26 09:01:01 -07:00
|
|
|
.faces(">Z")
|
2024-06-25 06:11:48 -07:00
|
|
|
.workplane()
|
2024-06-26 08:28:25 -07:00
|
|
|
.circle(self.diam_connector_external / 2)
|
2024-06-25 06:11:48 -07:00
|
|
|
.extrude(self.insertion_length)
|
|
|
|
)
|
2024-06-26 09:01:01 -07:00
|
|
|
if not self.simplify_geometry:
|
|
|
|
thread = self._external_thread().val()
|
|
|
|
result = (
|
|
|
|
result
|
|
|
|
.union(
|
|
|
|
thread
|
2024-06-26 16:27:36 -07:00
|
|
|
.located(Cq.Location((0, 0, self.connector_length / 2))))
|
2024-06-26 09:01:01 -07:00
|
|
|
)
|
2024-06-25 06:11:48 -07:00
|
|
|
return result
|
2024-07-01 17:59:42 -07:00
|
|
|
|
|
|
|
def threaded_core(self, length):
|
|
|
|
"""
|
|
|
|
Generates a threaded core for unioning with other components
|
|
|
|
"""
|
|
|
|
result = (
|
|
|
|
Cq.Workplane('XY')
|
|
|
|
.cylinder(
|
|
|
|
radius=self.diam_connector_external / 2,
|
|
|
|
height=length,
|
|
|
|
centered=(True, True, False),
|
|
|
|
)
|
|
|
|
)
|
|
|
|
result.faces(">Z").tag("mate")
|
|
|
|
result.faces("<Z").tag("base")
|
|
|
|
if not self.simplify_geometry:
|
|
|
|
thread = self._external_thread(length=length).val()
|
|
|
|
result = (
|
|
|
|
result
|
|
|
|
.union(thread)
|
|
|
|
)
|
|
|
|
return result
|
2024-06-25 06:11:48 -07:00
|
|
|
|
|
|
|
def connector_insertion_assembly(self):
|
|
|
|
connector_color = Cq.Color(0.8,0.8,0.5,0.3)
|
|
|
|
insertion_color = Cq.Color(0.7,0.7,0.7,0.3)
|
|
|
|
result = (
|
|
|
|
Cq.Assembly()
|
|
|
|
.add(self.connector(), name="c", color=connector_color)
|
|
|
|
.add(self.insertion(), name="i1", color=insertion_color)
|
|
|
|
.add(self.insertion(), name="i2", color=insertion_color)
|
|
|
|
.constrain("c?mate1", "i1?mate", "Plane")
|
|
|
|
.constrain("c?mate2", "i2?mate", "Plane")
|
|
|
|
.solve()
|
|
|
|
)
|
|
|
|
return result
|
|
|
|
def connector_one_side_insertion_assembly(self):
|
|
|
|
connector_color = Cq.Color(0.8,0.8,0.5,0.3)
|
|
|
|
insertion_color = Cq.Color(0.7,0.7,0.7,0.3)
|
|
|
|
result = (
|
|
|
|
Cq.Assembly()
|
|
|
|
.add(self.insertion(), name="i", color=connector_color)
|
|
|
|
.add(self.one_side_connector(), name="c", color=insertion_color)
|
|
|
|
.constrain("i?mate", "c?mate", "Plane")
|
|
|
|
.solve()
|
|
|
|
)
|
|
|
|
return result
|